dos_header:

db "MZ"

dw 0, 1, 0, 4/*Header size in paragraphs*/, 0, 0
dw 0, 0xFFFE  // stack
dw 0  // csum
dw offset dos_main, 0  // ip, cs
dw 0, 0
dw 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 0, 0
dd offset pe_header  // lfanew

[bits 16]

dos_str: db "Requires 32 bit OS\0"

dos_writez:

l_dos_writez_1:
  mov al, [cs:si]
  inc si
  or al, al
  jz l_dos_writez_9
    mov ah, 0Eh
    xor bh, bh
    int 10h
    jmp l_dos_writez_1

l_dos_writez_9:
ret


dos_main:
mov si, offset dos_str
call dos_writez

dos_end:
mov ax, 4C00h
int 21h

IMAGE_BASE = 0x6FF50000

COFS = IMAGE_BASE + 0x1000 - 0x400
CRVA = 0x1000 - 0x400

WM_KEYDOWN = 100h
WM_KEYUP   = 101h
WM_COMMAND = 111h
WM_TIMER   = 113h

VK_LEFT = 37
VK_RIGHT = 39
VK_UP = 38
VK_DOWN = 40
VK_ENTER = 13
VK_ESC = 27
VK_BSP = 8
VK_TAB = 9
VK_HOME = 36
VK_END = 35
VK_PGUP = 33
VK_PGDN = 34
VK_INS = 45
VK_DEL = 46

KBD_RSH  = 1
KBD_LSH  = 2
KBD_CTRL = 4
KBD_ALT  = 8
KBD_SCRLK = 0x10
KBD_NUMLK = 0x20
KBD_CPSLK = 0x40
KBD_INS   = 0x80
KBD_RCTRL = 0x400
KBD_RALT  = 0x800
KBD_VCTRL = 0x1000

FOPEN_READ = 1
FOPEN_WRITE = 3
FOPEN_APPEND = 10h
FOPEN_CREATE = 20h

FILE_ATTRIBUTE_READONLY  = 0x00000001
FILE_ATTRIBUTE_HIDDEN    = 0x00000002
FILE_ATTRIBUTE_SYSTEM    = 0x00000004
FILE_ATTRIBUTE_DIRECTORY = 0x00000010
FILE_ATTRIBUTE_ARCHIVE   = 0x00000020
FILE_ATTRIBUTE_DEVICE    = 0x00000040
FILE_ATTRIBUTE_NORMAL    = 0x00000080
FILE_ATTRIBUTE_TEMPORARY     = 0x00000100
FILE_ATTRIBUTE_SPARSE_FILE   = 0x00000200
FILE_ATTRIBUTE_REPARSE_POINT = 0x00000400
FILE_ATTRIBUTE_COMPRESSED    = 0x00000800
FILE_ATTRIBUTE_OFFLINE       = 0x00001000
FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = 0x00002000
FILE_ATTRIBUTE_ENCRYPTED       = 0x00004000
FILE_ATTRIBUTE_VALID_FLAGS     = 0x00007fb7
FILE_ATTRIBUTE_VALID_SET_FLAGS = 0x000031a7
FILE_ATTRIBUTE_LINUX = 0x08000000
FILE_ATTRIBUTE_LINK  = 0x04000000

ACCESS_R = 4 //read
ACCESS_W = 2 //write
ACCESS_X = 1 //execute

FSID_EXT2 = 82h
FSID_NTFS = 7
FSID_FAT12 = 0F0h
FSID_CD = 30h

EXT2_FEATURE_RO_COMPAT_SPARSE_SUPER = 0x0001 // Sparse Superblock
EXT2_FEATURE_RO_COMPAT_LARGE_FILE = 0x0002   // 64-bit file size
EXT2_FEATURE_RO_COMPAT_BTREE_DIR = 0x0004    // Binary tree sorted directories

struct StringBuilder{
  uns4 len, max
  ptr4 data
}

[dorg 0x6FF58000]

uns8 num, time
uns4 time_zone

ERC_OUT_OF_RANGE        = 5
ERC_DISK_CHANGED        = 6
ERC_NOT_FLUSHED         = 7
ERC_DISK_IO             = 8
ERC_INVALID_DISK_NUMBER = 10h
ERC_NOT_FOUND_IN_CACHE  = 12h
ERC_UNKNOWN_GEOMETRY    = 15h
ERC_DISK_FULL           = 16h

ERC_NOT_IMPLEMENTED     = 0FFh

ERC_INVALID_CHANNEL_NUMBER = 18h
ERC_INVALID_MEMORY_ADDRESS = 19h
ERC_INVALID_COUNT          = 1Ah

ERC_NOT_ENOUGH_MEMORY = 21h
ERC_ALIGN             = 24h
ERC_ALREADY_FREE      = 25h
ERC_OVERFLOW          = 26h
ERC_UNDERFLOW         = 27h

ERC_MSG_QUEUE_EMPTY    = 30h
ERC_MSG_QUEUE_FULL     = 31h
ERC_MSG_INVALID_TARGET = 32h

ERC_TOO_MANY_PROCS   = 40h
ERC_TOO_MANY_THREADS = 41h

ERC_TIMER_FULL      = 42
ERC_TIMER_NOT_FOUND = 43

ERC_PATH_NOT_FOUND = 44h
ERC_FILE_NOT_FOUND = 45h
ERC_TOO_MANY_OPEN_FILES = 46h
ERC_DIR_ALREADY_EXISTS = 47h
ERC_UNKNOWN_FILESYSTEM = 48h
ERC_DIR_NOT_EMPTY = 49h
ERC_CANT_REMOVE = 4Ah
ERC_DUPLICATE_NAME = 4Bh
ERC_INVALID_FHANDLE = 4Ch
ERC_INVALID_THREAD = 4Dh
ERC_FS = 4Eh
ERC_READ_ONLY = 4Fh
ERC_IN_USE = 50h
ERC_OUT_OF_DISK = 51h
ERC_TOO_MANY_SEARCHES = 52h
ERC_INVALID_SHANDLE = 53h
ERC_CANT_RENAME = 54h

ERC_INVALID_PID = 55h
ERC_STACK_OVERFLOW = 56h
ERC_INVALID_HEADER = 57h
ERC_INVALID_SERVICE = 58h

ERC_TOO_LONG = 59h
ERC_ONLY_STARTER = 5Ah
ERC_INVALID_MEMORY_LOCATION = 5Bh
ERC_INVALID_THREADID = 5Ch
ERC_ACCESS_DENIED = 5Dh
ERC_INVALID_PRIORITY = 5Eh
ERC_INVALID_ATRBS = 5Fh
ERC_INVALID_VALUE = 60h
ERC_INVALID_POINTER = 61h
ERC_INVALID_CHAR = 62h
ERC_DISK_REMOVED = 63h
ERC_TOO_BIG_HOLE = 64h
ERC_UTF8 = 65h
ERC_BUSY = 66h
ERC_DIR_TOO_BIG = 67h
ERC_LINK = 68h
ERC_NOT_A_LINK = 69h
ERC_INFINITE_LINK = 70h
ERC_CANT_MOVE = 71h
ERC_FILE_TOO_BIG = 72h

[align 32]

pe_header:

db "PE"

dw 0, 14Ch, 2/*Number of sections*/
dd 0, 0/*Pointer to symbol table*/, 0/*Number of symbols*/
dw 224 /*Size of optional header*/, 0 /*Characteristics*/

// Optional header
dw 0/*OH magic*/

db 0, 0
dd offset lastoffset /*Size of code*/
dd 0/*Size of initialized data*/, # - 0x6FF58000/*Size of uninitialized data*/
dd offset main + CRVA/*Address of entry point*/
dd 0/*Base of code*/, 0x10000/*Base of data*/

dd IMAGE_BASE/*Image base*/
dd 0x1000 /*Section alignment*/, 0x200 /*File alignment*/
dw 4, 0 /*OS version*/, 0, 0 /*Image version*/, 4, 0 /*Subsystem version*/
dd 0, 0x10000/*Size of image*/, 0x400/*Size of headers*/
dd 0 /*Checksum*/
dw 1/*Subsystem*/, 0/*DLL characteristics*/
dd 0x100000/*stack*/, 0x1000
dd 0x100000/*heap*/, 0x1000
dd 0/*Loader flags*/, 16/*RVA and sizes*/

// export
dd offset export + CRVA, 0x1000//...size of export
// import
dd 0,0
// other directories
dd 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0

// Section table [lfanew + 18h + sizeOfOptionalHeader]
db ".text   "
dd offset lastoffset // VSize
dd 0x1000 // RVA
dd offset lastoffset // Size of raw data
dd 0x400 // Pointer to raw data
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0x60000060 // Characteristics

db ".data   "
dd # - 0x6FF58000 // VSize
dd 0x8000 // RVA
dd 0 // Size of raw data
dd 0 // Pointer to raw data
dd 0 // Pointer to relocations
dd 0 // Pointer to line numbers
dw 0 // Number of relocations
dw 0 // Number of line numbers
dd 0xC0000040 // Characteristics

times 0x400 - $, 0

[bits 32]

jmp main

// IN: dl = x, dh = y
curto:
push ecx
 push esi
  push edx
   push edi
    push ebx
  
     mov ah, 3
     int 20h
  
    pop ebx
   pop edi
  pop edx
 pop esi
pop ecx
ret

// IN: esi -> string, ecx = length, bl = color
write:
push edx
 push edi
  push ebx
  
  mov ah, 2
  int 20h
  
  pop ebx
 pop edi
pop edx
ret

// IN: eax = number, ecx = system, bl = color
writen:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writen_1
		mov ecx, 10		// ecx must be >= 2

	l_writen_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writen_2
			add dl, '0'
			jmp short l_writen_3

		l_writen_2:
			add dl, 55

		l_writen_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writen_1
	
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
      dec esi
      inc ecx
      mov [esi], dl
      
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

// IN: eax = number, ecx = system, bl = color, bh = minlen
writemin:
push ecx
 push edx
  push esi
   push edi

    sub esp, 36

	// Parse digits from the number

	mov esi, esp
	add esi, 36
	cmp ecx, 2
	jnb l_writemin_1
		mov ecx, 10		// ecx must be >= 2

	l_writemin_1:
		xor edx, edx
		div ecx
		cmp dl, 10
		jnb l_writemin_2
			add dl, '0'
			jmp short l_writemin_3

		l_writemin_2:
			add dl, 55

		l_writemin_3:
		dec esi
		mov [esi], dl
		or eax, eax
		jnz l_writemin_1
	
	cmp bh, 36
	jb l_writemin_4
	  mov bh, 36
	  
	l_writemin_4:
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	mov dl, ' '
	
	l_writemin_5:
	  cmp cl, bh
	  jnb l_writemin_6
          dec esi
          inc ecx
          mov [esi], dl
          jmp short l_writemin_5
      
	l_writemin_6:	  
	mov ecx, esp
	add ecx, 36
	sub ecx, esi  // ecx = len
	
	call write
	
    add esp, 36

    pop edi
  pop esi
 pop edx
pop ecx
ret

THOUSAND_SEPARATOR = ','

// IN: edx:eax = number, ecx = system, bl = color
writen8:
push ecx
 push esi
  push edi

    sub esp, 72

    // Parse digits from the number
    mov esi, esp
    add esi, 72

    mov dword ptr num[0], eax
    mov dword ptr num[4], edx
    xor bh, bh

    cmp ecx, 2
    jnb l_writen8_1
      mov ecx, 10		// ecx must be >= 2
    
    l_writen8_1:
      cmp bh, 3
      jb l_writen_12
        dec esi
        mov byte ptr [esi], THOUSAND_SEPARATOR
        xor bh, bh
        
      l_writen_12:
      inc bh
      xor edx, edx
      mov eax, dword ptr num[4]
      div ecx
      mov dword ptr num[4], eax
      mov eax, dword ptr num[0]
      div ecx
      mov dword ptr num[0], eax
      
      cmp dl, 10
      jnb l_writen8_2
        add dl, '0'
        jmp short l_writen8_3
      
      l_writen8_2:
        add dl, 55
      
      l_writen8_3:
      dec esi
      mov [esi], dl
      
      mov eax, dword ptr num[0]
      mov edx, dword ptr num[4]
      test eax, eax
      jnz l_writen8_1
        test edx, edx
        jnz l_writen8_1
      
    mov ecx, esp
    add ecx, 72
    sub ecx, esi  // ecx = len
    mov dl, ' '
    
    dec esi
    inc ecx
    mov [esi], dl
     
    call write
     
    add esp, 72
    
  pop edi
 pop esi
pop ecx
ret

// IN: edx -> path & mask, edi -> SearchRec
// OUT: al = 0 || erc
find_first:
mov ah, 22
int 20h
cmp al, ERC_BUSY
jnz l_find_first_9
  call noop
  jmp short find_first
  
l_find_first_9:
ret

// IN: edi -> SearchRec
// OUT: al = 0 || erc
find_next:
mov ah, 23
int 20h
cmp al, ERC_BUSY
jnz l_find_next_9
  call noop
  jmp short find_next
  
l_find_next_9:
ret

// IN: edi -> SearchRec
find_close:
mov ah, 48
int 20h
ret

// IN: edx -> pathz
cdir:
mov ah, 16
int 20h
cmp al, ERC_BUSY
jnz l_cdir_9
  call noop
  jmp short cdir
  
l_cdir_9:
ret

// IN: edi -> buffer[MAX_PATH]
// OUT: al = 0 || erc
get_current_directory:
mov ah, 52
int 20h
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopen:
mov esi, 3
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopen_9
  call noop
  jmp short fopen
  
l_fopen_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fopenread:
mov esi, 1
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fopenread_9
  call noop
  jmp short fopenread
  
l_fopenread_9:
ret

// IN: edx -> filenamez
// OUT: ebx = fhandle
fcreate:
mov esi, 20h
mov ah, 8
int 20h
cmp al, ERC_BUSY
jnz l_fcreate_9
  call noop
  jmp short fcreate
  
l_fcreate_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fpos
fgetpos:
mov ah, 14
int 20h
cmp al, ERC_BUSY
jnz l_fgetpos_9
  call noop
  jmp short fgetpos
  
l_fgetpos_9:
ret

// IN: ebx = fhandle, edx:edi = file offset
// OUT: al = erc
fsetpos:
mov ah, 12
int 20h
cmp al, ERC_BUSY
jnz l_fsetpos_9
  call noop
  jmp short fsetpos
  
l_fsetpos_9:
ret

// IN: ebx = fhandle
// OUT: edx:ecx = fsize
fgetsize:
mov ah, 15
int 20h
cmp al, ERC_BUSY
jnz l_fgetsize_9
  call noop
  jmp short fgetsize
  
l_fgetsize_9:
ret

// IN: ebx = fhandle
fclose:
mov ah, 9
int 20h
cmp al, ERC_BUSY
jnz l_fclose_9
  call noop
  jmp short fclose
  
l_fclose_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size read
fread:
mov ah, 10
int 20h
cmp al, ERC_BUSY
jnz l_fread_9
  call noop
  jmp short fread
  
l_fread_9:
ret

// IN: ebx = fhandle, edi -> data, ecx = size
// OUT: al = erc, ecx = size write
fwrite:
mov ah, 11
int 20h
cmp al, ERC_BUSY
jnz l_fwrite_9
  call noop
  jmp short fwrite
  
l_fwrite_9:
ret

// IN: edx -> filenamez
rm:
mov ah, 18
int 20h
cmp al, ERC_BUSY
jnz l_rm_9
  call noop
  jmp short rm
  
l_rm_9:
ret

// IN: edx -> filenamez
md:
mov ah, 17
int 20h
cmp al, ERC_BUSY
jnz l_md_9
  call noop
  jmp short md
  
l_md_9:
ret

// IN: edx -> path & filenamez, esi -> new filenamez
// OUT: al = erc
ren:
mov ah, 20
int 20h
cmp al, ERC_BUSY
jnz l_ren_9
  call noop
  jmp short ren
  
l_ren_9:
ret

// IN: edx -> filenamez, esi -> new path
mv:
mov ah, 21
int 20h
cmp al, ERC_BUSY
jnz l_mv_9
  call noop
  jmp short mv
  
l_mv_9:
ret

// IN: esi = ldiskn
resetdisk:
mov ah, 63
int 20h
ret

// IN: edx -> filenamez, esi = mode
// OUT: al = erc, ebx = fhandle
open_link:
mov ah, 66
int 20h
cmp al, ERC_BUSY
jnz l_open_link_9
  call noop
  jmp short open_link
  
l_open_link_9:
ret

// IN: edx -> filenamez
// OUT: al = erc
rm_link:
mov ah, 67
int 20h
cmp al, ERC_BUSY
jnz l_rm_link_9
  call noop
  jmp short rm_link
  
l_rm_link_9:
ret

// IN: al = ldiskn
// OUT: al = erc
flush:
movzx esi, al

l_flush_1:
mov ah, 39 
int 20h
cmp al, ERC_BUSY
jnz l_flush_9
  call noop
  jmp short l_flush_1
  
l_flush_9:
ret

// IN: ebx = fhandle
// OUT: al = erc, edx:ecx = ftime
get_mtime:
mov ah, 74
int 20h
cmp al, ERC_BUSY
jnz l_get_mtime_9
  call noop
  jmp short get_mtime
  
l_get_mtime_9:
ret

// IN: ebx = fhandle, edx:ecx = ftime
// OUT: al = erc
set_mtime:
mov ah, 75
int 20h
cmp al, ERC_BUSY
jnz l_set_mtime_9
  call noop
  jmp short set_mtime
  
l_set_mtime_9:
ret

// IN: edx -> filenamez, esi = atrbs
// OUT: al = errorcode
// differrent behavior for windows and linux
chmod:
mov ah, 76
int 20h
cmp al, ERC_BUSY
jnz l_chmod_9
  call noop
  jmp short chmod
  
l_chmod_9:
ret

// only starter, root
// IN: edx -> filenamez, esi = new owner
// OUT: al = erc
chown:
mov ah, 78
int 20h
cmp al, ERC_BUSY
jnz l_chown_9
  call noop
  jmp short chown
  
l_chown_9:
ret

// only starter, root or owner
// IN: edx -> filenamez, esi = new group
// OUT: al = erc
chgrp:
mov ah, 79
int 20h
cmp al, ERC_BUSY
jnz l_chgrp_9
  call noop
  jmp short chgrp
  
l_chgrp_9:
ret

// IN: edx -> filenamez
// OUT: al = erc, ecx = uid, edx = gid
fuidgid:
mov ah, 82
int 20h
cmp al, ERC_BUSY
jnz l_fuidgid_9
  call noop
  jmp short fuidgid
  
l_fuidgid_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> target
disk_read:
mov ah, 36
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_9
  call noop
  jmp short disk_read
  
l_disk_read_9:
ret

// only starter
// IN: edx:ebx = disk offset, ecx = size,
//     esi = logical disk number, edi -> source
disk_write:
mov ah, 37
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_9
  call noop
  jmp short disk_write
  
l_disk_write_9:
ret

// OUT: al = logical disk number
get_boot_disk:
mov ah, 77
int 20h
movzx eax, al
ret

// OUT: al = logical disk number
get_users_disk:
mov ah, 83
int 20h
movzx eax, al
ret

// IN: esi = logical disk number
// OUT: al = type (2:fd, 3:cd, 4:hd), ah = pdiskn,
//      edx:ecx = disk size in sectors, edi:esi = base in sectors
get_disk_type:
mov ah, 53
int 20h
ret

// IN: esi = logical disk number
// OUT: edx:eax = disk size in bytes
get_disk_size:
mov ah, 38
int 20h
ret

// IN: al = ldiskn
// OUT: cl = erc, edx:eax = free bytes)
disk_free:
mov esi, eax

l_disk_free_1:
mov ah, 68
int 20h
cmp al, ERC_BUSY
jnz l_disk_free_9
  call noop
  jmp short l_disk_free_1
  
l_disk_free_9:
xchg eax, ecx
ret

// IN: al = ldiskn
// OUT: al = erc
reset_disk:
mov esi, eax

l_reset_disk_1:
mov ah, 63
int 20h
cmp al, ERC_BUSY
jnz l_reset_disk_9
  call noop
  jmp short l_reset_disk_1
  
l_reset_disk_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_read_sector:
mov ah, 40
int 20h
cmp al, ERC_BUSY
jnz l_disk_read_sector_9
  call noop
  jmp short disk_read_sector
  
l_disk_read_sector_9:
ret

// IN: edx:ebx = sector, ecx = count, edi -> data,
//     esi = physical HD number
disk_write_sector:
mov ah, 41
int 20h
cmp al, ERC_BUSY
jnz l_disk_write_sector_9
  call noop
  jmp short disk_write_sector
  
l_disk_write_sector_9:
ret

noop:
mov ah, 0
int 20h
ret

// IN: ecx = size
// OUT: al = erc, ebx = ptr
malloc:
mov ah, 24
int 20h
ret

// IN: ebx = ptr
free:
mov ah, 25
int 20h
ret

// OUT: al = 0 || errorcode, ebx = wnd:sender, ecx = msg, edx = wp, esi = lp
getmsg:
mov ah, 5 // get system message
int 20h
or al, al
jz l_getmsg_9
  mov ah, 7 // get message
  int 20h
  or al, al
  jz l_getmsg_9
    mov ah, 45 // get pid, tid; OUT: edi = tid
    int 20h
    mov ah, 35 // stop thread
    int 20h
    jmp short getmsg
  
l_getmsg_9:
ret

// KEEP: ebx, ebp
waitkey:
push ebx
 push ebp

  l_waitkey_5:
    mov ah, 45 // get pid, tid; OUT: edi = tid
    int 20h
    mov ah, 35 // stop thread
    int 20h
    call getmsg
    cmp ecx, WM_KEYDOWN
    jnz l_waitkey_5

 pop ebp
pop ebx
ret

// IN: esi -> ftime, edi -> SystemTime
ftime2local:
mov eax, time_zone
mov ecx, 3600
imul ecx
mov ecx, 10000000
imul ecx

add eax, [esi]
adc edx, [esi + 4]
mov dword ptr time[0], eax
mov dword ptr time[4], edx

mov esi, offset time
mov ah, 59
int 20h
ret

// IN: ecx = uid, edi -> byte[256]
getuserinfo:
mov ah, 80
int 20h
cmp al, ERC_BUSY
jnz l_getuserinfo_9
  call noop
  jmp short getuserinfo
  
l_getuserinfo_9:
ret

// IN: ecx = gid, edi -> byte[256]
getgroupinfo:
mov ah, 81
int 20h
cmp al, ERC_BUSY
jnz l_getgroupinfo_9
  call noop
  jmp short getgroupinfo
  
l_getgroupinfo_9:
ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_init:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

// IN: esi -> StringBuilder, edi -> data, ecx = len
// OUT: al = erc (0: ok, 1: not enough memory)
// KEEP: esi
sb_add:
mov edx, [esi + offset StringBuilder.max]
mov eax, [esi + offset StringBuilder.len]
add eax, ecx
cmp eax, edx
jna l_sb_add2
  // len + ecx > max
  cmp edx, 16
  jnb l_sb_add11
    mov edx, 16
    
  l_sb_add11:
  cmp eax, edx
  jna l_sb_add14
    shl edx, 1
    cmp edx, 0
    jnz l_sb_add11
      
      l_sb_add13:
      
      mov al, 1
      
      ret
    
  l_sb_add14:
  // allocate a new block
  push esi
   push edi
    push ecx
     push edx
      mov ecx, edx
      call malloc
      // OUT: ebx
     pop edx
    pop ecx
   pop edi
  pop esi
  or al, al
  jnz l_sb_add13
  
  // copy old data to the new block
  mov [esi + offset StringBuilder.max], edx
  push esi
   push edi
    push ecx
     push ebx
       mov ecx, [esi + offset StringBuilder.len]
       mov esi, [esi + offset StringBuilder.data]
       mov edi, ebx
       mov ebx, esi
       cld
       rep movsb
       
       // free the old block
       or ebx, ebx
       jz l_sb_add18
         call free
         
       l_sb_add18:
     pop ebx 
    pop ecx
   pop edi
  pop esi
  mov [esi + offset StringBuilder.data], ebx

l_sb_add2:
// copy data
mov ebx, edi
mov edi, [esi + offset StringBuilder.data]
add edi, [esi + offset StringBuilder.len]
add [esi + offset StringBuilder.len], ecx

push esi
  mov esi, ebx
  cld
  rep movsb
pop esi

mov al, 0

ret

// IN: esi -> StringBuilder
// KEEP: esi
sb_done:
mov ebx, [esi + offset StringBuilder.data]
or ebx, ebx
jz sb_done_2
  
  push esi
  
    call free
  
  pop esi
  
sb_done_2:
xor eax, eax
mov [esi + offset StringBuilder.len], eax
mov [esi + offset StringBuilder.max], eax
mov [esi + offset StringBuilder.data], eax
ret

main:

ret

getmainargs:
xor eax, eax
ret

environ:
mov eax, 0 // _environ
ret

fmode:
mov eax, 0  // _fmode
ret

setaptype:
xor eax, eax
ret

cexit:
//... ExitProcess
ret

iob:
//... var?
//ret

onexit:
//...
ret

setmode:
//...
ret

abort:
//... no return?
ret

atexit:
ret

fflush:
//...
ret

fprintf:
//...
ret

xfree:
//...
ret

xmalloc:
//...
ret

signal:
//...
ret

[fill 0x1000]

export:
dd 0/*export flags*/, 0/*dtm stamp*/
dw 0, 0/*major, minor version*/
dd offset dll_name + CRVA/*name RVA*/
dd 1/*ordinal base*/
dd 15/*number of address table entries*/
dd 15/*number of name pointers*/
dd offset export_table + CRVA/*export address table RVA*/
dd offset name_pointers + CRVA/*name pointers RVA*/
dd offset ordinal_table + CRVA/*ordinal table RVA*/

export_table:
dd offset getmainargs + CRVA
dd offset environ + CRVA
dd offset fmode + CRVA
dd offset setaptype + CRVA
dd offset cexit + CRVA
dd offset iob + CRVA
dd offset onexit + CRVA
dd offset setmode + CRVA
dd offset abort + CRVA
dd offset atexit + CRVA
dd offset fflush + CRVA
dd offset fprintf + CRVA
dd offset xfree + CRVA
dd offset xmalloc + CRVA
dd offset signal + CRVA

name_pointers:
dd offset np_getmainargs + CRVA
dd offset np_environ + CRVA
dd offset np_fmode + CRVA
dd offset np_setaptype + CRVA
dd offset np_cexit + CRVA
dd offset np_iob + CRVA
dd offset np_onexit + CRVA
dd offset np_setmode + CRVA
dd offset np_abort + CRVA
dd offset np_atexit + CRVA
dd offset np_fflush + CRVA
dd offset np_fprintf + CRVA
dd offset np_free + CRVA
dd offset np_malloc + CRVA
dd offset np_signal + CRVA

ordinal_table:
dw 0
dw 1
dw 2
dw 3
dw 4
dw 5
dw 6
dw 7
dw 8
dw 9
dw 10
dw 11
dw 12
dw 13
dw 14

dll_name: db "msvcrt.dll\0"

np_getmainargs: db "__getmainargs\0"
np_environ: db "__p__environ\0"
np_fmode: db "__p__fmode\0"
np_setaptype: db "__set_app_type\0"
np_cexit: db "_cexit\0"
np_iob: db "_iob\0"
np_onexit: db "_onexit\0"
np_setmode: db "_setmode\0"
np_abort: db "abort\0"
np_atexit: db "atexit\0"
np_fflush: db "fflush\0"
np_fprintf: db "fprintf\0"
np_free: db "free\0"
np_malloc: db "malloc\0"
np_signal: db "signal\0"

export_lastoffset:

lastoffset:

